--- old/usr/src/tools/smatch/src/smatch_struct_assignment.c	Sat Nov 16 11:16:51 2019
+++ new/usr/src/tools/smatch/src/smatch_struct_assignment.c	Sat Nov 16 11:16:51 2019
@@ -167,7 +167,8 @@
 	if (type->type != SYM_BASETYPE)
 		return;
 	right = strip_expr(right);
-	if (!right)
+	type = get_type(right);
+	if (!right || !type || type->type == SYM_ARRAY)
 		right = unknown_value_expression(left);
 	assign = assign_expression(left, '=', right);
 	split_fake_expr(assign);
@@ -404,7 +405,7 @@
 	if (expr->op != '=')
 		return;
 
-	if (is_zero(expr->right))
+	if (expr_is_zero(expr->right))
 		return;
 
 	left_type = get_type(expr->left);
